Index: sys/dev/awi/awi_wep.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/awi/awi_wep.c,v
retrieving revision 1.5
diff -u -r1.5 awi_wep.c
--- sys/dev/awi/awi_wep.c	2001/09/12 08:37:02	1.5
+++ sys/dev/awi/awi_wep.c	2001/09/24 17:55:16
@@ -53,6 +53,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/kernel.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/proc.h>
 #include <sys/malloc.h>
Index: sys/dev/awi/awi_wicfg.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/awi/awi_wicfg.c,v
retrieving revision 1.5
diff -u -r1.5 awi_wicfg.c
--- sys/dev/awi/awi_wicfg.c	2001/09/12 08:37:02	1.5
+++ sys/dev/awi/awi_wicfg.c	2001/09/24 17:58:50
@@ -44,6 +44,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/kernel.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/proc.h>
 #include <sys/malloc.h>
Index: sys/dev/bge/if_bge.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/bge/if_bge.c,v
retrieving revision 1.3
diff -u -r1.3 if_bge.c
--- sys/dev/bge/if_bge.c	2001/09/29 19:31:29	1.3
+++ sys/dev/bge/if_bge.c	2001/10/03 03:16:34
@@ -73,6 +73,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/malloc.h>
 #include <sys/kernel.h>
Index: sys/dev/cnw/if_cnw.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/cnw/if_cnw.c,v
retrieving revision 1.3
diff -u -r1.3 if_cnw.c
--- sys/dev/cnw/if_cnw.c	2001/05/08 23:57:32	1.3
+++ sys/dev/cnw/if_cnw.c	2001/09/25 11:43:10
@@ -231,6 +231,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/malloc.h>
 #include <sys/kernel.h>
Index: sys/dev/cs/if_cs.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/cs/if_cs.c,v
retrieving revision 1.20
diff -u -r1.20 if_cs.c
--- sys/dev/cs/if_cs.c	2001/02/23 08:08:21	1.20
+++ sys/dev/cs/if_cs.c	2001/09/24 17:59:13
@@ -40,6 +40,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/malloc.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
 #include <sys/sockio.h>
Index: sys/dev/ed/if_ed.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/ed/if_ed.c,v
retrieving revision 1.203
diff -u -r1.203 if_ed.c
--- sys/dev/ed/if_ed.c	2001/10/07 00:18:48	1.203
+++ sys/dev/ed/if_ed.c	2001/10/08 02:03:25
@@ -42,6 +42,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/kernel.h>
 #include <sys/socket.h>
Index: sys/dev/ep/if_ep.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/ep/if_ep.c,v
retrieving revision 1.107
diff -u -r1.107 if_ep.c
--- sys/dev/ep/if_ep.c	2001/06/05 22:29:16	1.107
+++ sys/dev/ep/if_ep.c	2001/09/24 18:01:35
@@ -63,6 +63,7 @@
 
 #include <sys/param.h>
 #include <sys/systm.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
 #include <sys/sockio.h>
Index: sys/dev/ex/if_ex.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/ex/if_ex.c,v
retrieving revision 1.37
diff -u -r1.37 if_ex.c
--- sys/dev/ex/if_ex.c	2001/02/04 13:11:49	1.37
+++ sys/dev/ex/if_ex.c	2001/09/24 18:01:51
@@ -42,6 +42,7 @@
 #include <sys/systm.h>
 #include <sys/kernel.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
 
Index: sys/dev/fe/if_fe.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/fe/if_fe.c,v
retrieving revision 1.71
diff -u -r1.71 if_fe.c
--- sys/dev/fe/if_fe.c	2001/09/02 13:05:00	1.71
+++ sys/dev/fe/if_fe.c	2001/09/24 18:02:47
@@ -72,6 +72,7 @@
 #include <sys/systm.h>
 #include <sys/socket.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 
 #include <sys/bus.h>
Index: sys/dev/fxp/if_fxp.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/fxp/if_fxp.c,v
retrieving revision 1.118
diff -u -r1.118 if_fxp.c
--- sys/dev/fxp/if_fxp.c	2001/09/05 23:33:58	1.118
+++ sys/dev/fxp/if_fxp.c	2001/09/24 18:03:32
@@ -34,6 +34,7 @@
 
 #include <sys/param.h>
 #include <sys/systm.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/malloc.h>
 		/* #include <sys/mutex.h> */
Index: sys/dev/ie/if_ie.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/ie/if_ie.c,v
retrieving revision 1.83
diff -u -r1.83 if_ie.c
--- sys/dev/ie/if_ie.c	2001/07/02 05:29:58	1.83
+++ sys/dev/ie/if_ie.c	2001/09/25 11:43:46
@@ -116,6 +116,7 @@
 #include <sys/systm.h>
 #include <sys/eventhandler.h>
 #include <sys/kernel.h>
+#include <sys/mac.h>
 #include <sys/malloc.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
Index: sys/dev/iicbus/if_ic.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/iicbus/if_ic.c,v
retrieving revision 1.10
diff -u -r1.10 if_ic.c
--- sys/dev/iicbus/if_ic.c	2000/11/25 07:35:22	1.10
+++ sys/dev/iicbus/if_ic.c	2001/09/25 11:44:35
@@ -33,6 +33,7 @@
 #ifdef _KERNEL
 #include <sys/param.h>
 #include <sys/systm.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
 #include <sys/filio.h>
@@ -48,6 +49,7 @@
 #include <net/netisr.h>
 
 #endif
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
 #include <net/netisr.h>
Index: sys/dev/lge/if_lge.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/lge/if_lge.c,v
retrieving revision 1.9
diff -u -r1.9 if_lge.c
--- sys/dev/lge/if_lge.c	2001/09/29 19:31:29	1.9
+++ sys/dev/lge/if_lge.c	2001/10/01 16:30:49
@@ -76,6 +76,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/malloc.h>
 #include <sys/kernel.h>
Index: sys/dev/lmc/if_lmc.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/lmc/if_lmc.c,v
retrieving revision 1.13
diff -u -r1.13 if_lmc.c
--- sys/dev/lmc/if_lmc.c	2001/01/17 01:08:50	1.13
+++ sys/dev/lmc/if_lmc.c	2001/09/25 11:46:04
@@ -37,6 +37,7 @@
 #include "opt_netgraph.h"
 #include <sys/param.h>
 #include <sys/systm.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
 #include <sys/errno.h>
Index: sys/dev/lnc/if_lnc.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/lnc/if_lnc.c,v
retrieving revision 1.89
diff -u -r1.89 if_lnc.c
--- sys/dev/lnc/if_lnc.c	2001/07/04 13:00:19	1.89
+++ sys/dev/lnc/if_lnc.c	2001/09/24 18:04:05
@@ -65,6 +65,7 @@
 #include <sys/bus.h>
 #include <sys/kernel.h>
 #include <sys/malloc.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/module.h>
 #include <sys/socket.h>
Index: sys/dev/nge/if_nge.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/nge/if_nge.c,v
retrieving revision 1.23
diff -u -r1.23 if_nge.c
--- sys/dev/nge/if_nge.c	2001/09/29 19:31:29	1.23
+++ sys/dev/nge/if_nge.c	2001/10/01 16:30:54
@@ -90,6 +90,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/malloc.h>
 #include <sys/kernel.h>
Index: sys/dev/ppbus/if_plip.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/ppbus/if_plip.c,v
retrieving revision 1.22
diff -u -r1.22 if_plip.c
--- sys/dev/ppbus/if_plip.c	2000/11/25 07:35:23	1.22
+++ sys/dev/ppbus/if_plip.c	2001/09/24 18:05:10
@@ -84,6 +84,7 @@
 #include <sys/systm.h>
 #include <sys/module.h>
 #include <sys/bus.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
 #include <sys/sockio.h>
Index: sys/dev/ray/if_ray.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/ray/if_ray.c,v
retrieving revision 1.56
diff -u -r1.56 if_ray.c
--- sys/dev/ray/if_ray.c	2001/05/17 22:23:49	1.56
+++ sys/dev/ray/if_ray.c	2001/09/25 11:46:30
@@ -251,6 +251,7 @@
 #include <sys/bus.h>
 #include <sys/rman.h>
 
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
 #include <sys/sockio.h>
Index: sys/dev/sn/if_sn.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/sn/if_sn.c,v
retrieving revision 1.19
diff -u -r1.19 if_sn.c
--- sys/dev/sn/if_sn.c	2001/08/04 05:27:52	1.19
+++ sys/dev/sn/if_sn.c	2001/09/24 18:06:02
@@ -83,6 +83,7 @@
 #include <sys/systm.h>
 #include <sys/errno.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
 #include <sys/syslog.h>
Index: sys/dev/sr/if_sr.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/sr/if_sr.c,v
retrieving revision 1.47
diff -u -r1.47 if_sr.c
--- sys/dev/sr/if_sr.c	2001/02/26 16:30:02	1.47
+++ sys/dev/sr/if_sr.c	2001/09/25 11:46:44
@@ -55,6 +55,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/kernel.h>
+#include <sys/mac.h>
 #include <sys/malloc.h>
 #include <sys/mbuf.h>
 #include <sys/sockio.h>
Index: sys/dev/txp/if_txp.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/txp/if_txp.c,v
retrieving revision 1.7
diff -u -r1.7 if_txp.c
--- sys/dev/txp/if_txp.c	2001/09/18 18:41:39	1.7
+++ sys/dev/txp/if_txp.c	2001/09/24 18:07:11
@@ -42,6 +42,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/malloc.h>
 #include <sys/kernel.h>
Index: sys/dev/usb/if_aue.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/usb/if_aue.c,v
retrieving revision 1.43
diff -u -r1.43 if_aue.c
--- sys/dev/usb/if_aue.c	2001/09/29 19:31:29	1.43
+++ sys/dev/usb/if_aue.c	2001/10/01 16:31:09
@@ -64,6 +64,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/malloc.h>
 #include <sys/kernel.h>
Index: sys/dev/usb/if_cue.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/usb/if_cue.c,v
retrieving revision 1.19
diff -u -r1.19 if_cue.c
--- sys/dev/usb/if_cue.c	2001/08/22 05:33:57	1.19
+++ sys/dev/usb/if_cue.c	2001/09/24 18:07:53
@@ -53,6 +53,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/malloc.h>
 #include <sys/kernel.h>
Index: sys/dev/usb/if_kue.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/usb/if_kue.c,v
retrieving revision 1.32
diff -u -r1.32 if_kue.c
--- sys/dev/usb/if_kue.c	2001/08/22 05:33:57	1.32
+++ sys/dev/usb/if_kue.c	2001/09/24 18:08:04
@@ -67,6 +67,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/malloc.h>
 #include <sys/kernel.h>
Index: sys/dev/usb/udbp.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/usb/udbp.c,v
retrieving revision 1.13
diff -u -r1.13 udbp.c
--- sys/dev/usb/udbp.c	2001/01/09 04:33:17	1.13
+++ sys/dev/usb/udbp.c	2001/09/25 02:56:52
@@ -83,6 +83,7 @@
 #include <sys/select.h>
 #endif
 #include <sys/poll.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
 #include <sys/ctype.h>
Index: sys/dev/usb/usb_ethersubr.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/usb/usb_ethersubr.c,v
retrieving revision 1.9
diff -u -r1.9 usb_ethersubr.c
--- sys/dev/usb/usb_ethersubr.c	2000/11/25 07:35:24	1.9
+++ sys/dev/usb/usb_ethersubr.c	2001/09/24 18:08:51
@@ -53,6 +53,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/malloc.h>
 #include <sys/socket.h>
Index: sys/dev/vx/if_vx.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/vx/if_vx.c,v
retrieving revision 1.34
diff -u -r1.34 if_vx.c
--- sys/dev/vx/if_vx.c	2001/07/19 02:16:01	1.34
+++ sys/dev/vx/if_vx.c	2001/09/24 18:09:11
@@ -59,6 +59,7 @@
 #include <sys/systm.h>
 #include <sys/sockio.h>
 #include <sys/malloc.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
 
Index: sys/dev/wi/if_wi.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/wi/if_wi.c,v
retrieving revision 1.61
diff -u -r1.61 if_wi.c
--- sys/dev/wi/if_wi.c	2001/09/12 08:37:16	1.61
+++ sys/dev/wi/if_wi.c	2001/09/24 18:09:30
@@ -71,6 +71,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/proc.h>
 #include <sys/kernel.h>
Index: sys/dev/wl/if_wl.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/wl/if_wl.c,v
retrieving revision 1.39
diff -u -r1.39 if_wl.c
--- sys/dev/wl/if_wl.c	2001/09/12 08:37:16	1.39
+++ sys/dev/wl/if_wl.c	2001/09/25 11:47:03
@@ -196,6 +196,7 @@
 #include <sys/systm.h>
 #include <sys/kernel.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
 #include <sys/syslog.h>
Index: sys/dev/xe/if_xe.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/xe/if_xe.c,v
retrieving revision 1.28
diff -u -r1.28 if_xe.c
--- sys/dev/xe/if_xe.c	2001/08/29 05:11:44	1.28
+++ sys/dev/xe/if_xe.c	2001/09/24 18:09:48
@@ -112,6 +112,7 @@
 #include <sys/cdefs.h>
 #include <sys/errno.h>
 #include <sys/kernel.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
 #include <sys/sockio.h>
Index: sys/fs/procfs/procfs_vnops.c
===================================================================
RCS file: /home/ncvs/src/sys/fs/procfs/procfs_vnops.c,v
retrieving revision 1.103
diff -u -r1.103 procfs_vnops.c
--- sys/fs/procfs/procfs_vnops.c	2001/10/07 19:37:13	1.103
+++ sys/fs/procfs/procfs_vnops.c	2001/10/08 02:03:59
@@ -43,12 +43,15 @@
  * procfs vnode interface
  */
 
+#include "opt_mac.h"
+
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/dirent.h>
 #include <sys/fcntl.h>
 #include <sys/kernel.h>
 #include <sys/lock.h>
+#include <sys/mac.h>
 #include <sys/malloc.h>
 #include <sys/mount.h>
 #include <sys/mutex.h>
@@ -72,6 +75,9 @@
 static int	procfs_badop __P((void));
 static int	procfs_close __P((struct vop_close_args *));
 static int	procfs_getattr __P((struct vop_getattr_args *));
+#ifdef MAC
+static int	procfs_getlabel __P((struct vop_getlabel_args *));
+#endif
 static int	procfs_ioctl __P((struct vop_ioctl_args *));
 static int	procfs_lookup __P((struct vop_lookup_args *));
 static int	procfs_open __P((struct vop_open_args *));
@@ -563,7 +569,61 @@
 	return (error);
 }
 
+#ifdef MAC
 static int
+procfs_getlabel(ap)
+	struct vop_getlabel_args /* {
+		struct vnode *a_vp;
+		struct mac *a_label;
+		struct ucred *a_cred;
+		struct proc *a_p;
+	}; */ *ap;
+{
+	struct pfsnode *pfs = VTOPFS(ap->a_vp);
+	struct proc *procp;
+
+	switch (pfs->pfs_type) {
+	case Proot:
+	case Pcurproc:
+		procp = NULL;
+		break;
+
+	default:
+		procp = PFIND(pfs->pfs_pid);
+		if (procp == NULL)
+			return (ENOENT);
+
+		if (procp->p_ucred == NULL) {
+			PROC_UNLOCK(procp);
+			return (ENOENT);
+		}
+
+		if (p_cansee(ap->a_td->td_proc, procp)) {
+			PROC_UNLOCK(procp);
+			return (ENOENT);
+		}
+	}
+
+	if (procp == NULL) {
+		/*
+		 * Return the default object label for non-process
+		 * entries.  Might be better to replicate the label
+		 * of proc 0, or do the default subject label.
+		 */
+		mac_init_object(ap->a_label);
+	} else {
+		/*
+		 * Copy the process label.
+		 */
+		*ap->a_label = procp->p_ucred->cr_label;
+		PROC_UNLOCK(procp);
+	}
+
+	return (0);
+}
+#endif /* !MAC */
+
+static int
 procfs_setattr(ap)
 	struct vop_setattr_args /* {
 		struct vnode *a_vp;
@@ -997,6 +1057,9 @@
 	{ &vop_close_desc,		(vop_t *) procfs_close },
 	{ &vop_create_desc,		(vop_t *) procfs_badop },
 	{ &vop_getattr_desc,		(vop_t *) procfs_getattr },
+#if MAC
+	{ &vop_getlabel_desc,		(vop_t *) procfs_getlabel },
+#endif
 	{ &vop_link_desc,		(vop_t *) procfs_badop },
 	{ &vop_lookup_desc,		(vop_t *) procfs_lookup },
 	{ &vop_mkdir_desc,		(vop_t *) procfs_badop },
Index: sys/i386/i386/in_cksum.c
===================================================================
RCS file: /home/ncvs/src/sys/i386/i386/in_cksum.c,v
retrieving revision 1.22
diff -u -r1.22 in_cksum.c
--- sys/i386/i386/in_cksum.c	2000/11/25 03:01:05	1.22
+++ sys/i386/i386/in_cksum.c	2001/09/24 19:00:40
@@ -40,6 +40,7 @@
  */
 #include <sys/param.h>
 #include <sys/systm.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 
 #include <netinet/in.h>
Index: sys/i386/isa/if_cx.c
===================================================================
RCS file: /home/ncvs/src/sys/i386/isa/if_cx.c,v
retrieving revision 1.34
diff -u -r1.34 if_cx.c
--- sys/i386/isa/if_cx.c	2000/06/13 22:28:47	1.34
+++ sys/i386/isa/if_cx.c	2001/09/25 11:53:37
@@ -26,6 +26,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/kernel.h>
+#include <sys/mac.h>
 #include <sys/malloc.h>
 #include <sys/mbuf.h>
 #include <sys/sockio.h>
Index: sys/i386/isa/if_el.c
===================================================================
RCS file: /home/ncvs/src/sys/i386/isa/if_el.c,v
retrieving revision 1.54
diff -u -r1.54 if_el.c
--- sys/i386/isa/if_el.c	2001/02/09 06:09:28	1.54
+++ sys/i386/isa/if_el.c	2001/09/25 11:53:39
@@ -26,6 +26,7 @@
 #include <sys/systm.h>
 #include <sys/kernel.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
 #include <sys/syslog.h>
Index: sys/i386/isa/if_le.c
===================================================================
RCS file: /home/ncvs/src/sys/i386/isa/if_le.c,v
retrieving revision 1.64
diff -u -r1.64 if_le.c
--- sys/i386/isa/if_le.c	2001/02/06 10:11:19	1.64
+++ sys/i386/isa/if_le.c	2001/09/25 11:53:42
@@ -42,6 +42,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/kernel.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
 #include <sys/sockio.h>
Index: sys/i386/isa/if_rdp.c
===================================================================
RCS file: /home/ncvs/src/sys/i386/isa/if_rdp.c,v
retrieving revision 1.11
diff -u -r1.11 if_rdp.c
--- sys/i386/isa/if_rdp.c	2000/10/15 14:18:38	1.11
+++ sys/i386/isa/if_rdp.c	2001/09/25 11:53:44
@@ -67,6 +67,7 @@
 #include <sys/systm.h>
 #include <sys/kernel.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
 #include <sys/syslog.h>
Index: sys/kern/init_main.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/init_main.c,v
retrieving revision 1.177
diff -u -r1.177 init_main.c
--- sys/kern/init_main.c	2001/09/18 22:09:47	1.177
+++ sys/kern/init_main.c	2001/09/19 02:36:48
@@ -43,6 +43,7 @@
  */
 
 #include "opt_init_path.h"
+#include "opt_mac.h"
 
 #include <sys/param.h>
 #include <sys/file.h>
@@ -54,6 +55,7 @@
 #include <sys/mutex.h>
 #include <sys/sysctl.h>
 #include <sys/proc.h>
+#include <sys/mac.h>
 #include <sys/resourcevar.h>
 #include <sys/systm.h>
 #include <sys/signalvar.h>
@@ -345,6 +347,9 @@
 	p->p_ucred = crget();
 	p->p_ucred->cr_ngroups = 1;	/* group 0 */
 	p->p_ucred->cr_uidinfo = uifind(0);
+#ifdef MAC
+	mac_init_subject(p->p_ucred);
+#endif
 	p->p_ucred->cr_ruidinfo = uifind(0);
 	p->p_ucred->cr_prison = NULL;	/* Don't jail it. */
 
Index: sys/kern/kern_exec.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_exec.c,v
retrieving revision 1.141
diff -u -r1.141 kern_exec.c
--- sys/kern/kern_exec.c	2001/10/10 23:06:53	1.141
+++ sys/kern/kern_exec.c	2001/10/11 14:38:57
@@ -26,6 +26,8 @@
  * $FreeBSD: src/sys/kern/kern_exec.c,v 1.141 2001/10/10 23:06:53 ps Exp $
  */
 
+#include "opt_mac.h"
+
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/lock.h>
@@ -833,6 +835,22 @@
 	error = VOP_ACCESS(vp, VEXEC, p->p_ucred, curthread); /* XXXKSE */
 	if (error)
 		return (error);
+
+#ifdef MAC
+#if 0
+	{
+		struct mac label;
+
+		error = VOP_GETLABEL(vp, &label, curthread->td_proc->p_ucred,
+		    curthread);
+		if (error)
+			return (error);
+		error = mac_p_canexec(curthread->td_proc, &label);
+		if (error)
+			return (error);
+	}
+#endif /* !0 */
+#endif /* !MAC */
 
 	/*
 	 * Check number of open-for-writes on the file and deny execution
